(* Copyright 2011 Cornell University
 *
 *
 * This file is part of EventML - a tool aiming at specifying
 * distributed protocols in an ML like language.  It is an interface
 * to the logic of events and is compiled into Nuprl.  It is written
 * by the NUPRL group of Cornell University, Ithaca, NY.
 *
 * EventML is a free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EventML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventML.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  o Authors:     Vincent Rahli
 *  o Affiliation: Cornell University, NUPRL group
 *  o Date:        29 July 2011
 *  o File name:   Primitive.sig
 *  o Description: Some primitive functions
 *)


signature PRIMITIVE = sig

    val do_primitive_int_op : string                ->
			      NuprlTerms.nuprl_term ->
			      NuprlTerms.nuprl_term ->
			      NuprlTerms.nuprl_term

    val do_primitive_cmp : string                ->
			   NuprlTerms.nuprl_term ->
			   NuprlTerms.nuprl_term ->
			   bool

    val do_primitive_test : string                ->
			    NuprlTerms.nuprl_term ->
			    bool

    val do_primitive_minus : NuprlTerms.nuprl_term ->
			     NuprlTerms.nuprl_term

    val is_primitive_value : NuprlTerms.nuprl_term -> bool

    val is_complete_primitive_value : NuprlTerms.nuprl_term -> bool

    val compare_atomn : int                   ->
			NuprlTerms.nuprl_term ->
			NuprlTerms.nuprl_term ->
			bool

end
